package com.ether;

/**
 * @author vmipsl
 * @date 02 feb 2011
 */
public class WebException
        extends FormattedException
{
    public WebException( final Enum<? extends Code> code )
    {
        super( code );
    }

    public WebException( final Throwable throwable )
    {
        super( throwable );
    }

    public WebException( final Enum<? extends Code> code, final Throwable throwable, final Object... parameters )
    {
        this( code, throwable.getMessage(), throwable, parameters );
    }

    public WebException( final Enum<? extends Code> code, final String message, final Object... parameters )
    {
        super( code, message, DEFAULT_THROWABLE, parameters );
    }

    protected WebException( final Enum<? extends Code> code, final String message, final Throwable throwable, final Object... parameters )
    {
        super( formatThrowable( code, message, throwable ), throwable, parameters );
    }

    public static enum WebCode
            implements Code
    {
        ERROR_UNSUPPORTED_UTF8_ENCODING,
        ERROR_NO_REQUEST_HANDLING_METHOD,
        ERROR_NUMBER_OF_PARAM_TYPES_NOT_EQUAL_TO_PARAM_ANNOTATIONS,
        INVALID_DATE,
        PLATEFORM_OR_PARAMETER_IS_NULL,
        PARAMETER_IS_NULL,
        USER_ALREADY_EXISTS,
        ERROR_EMAIL_CANNOT_BE_SEND,
        ERROR_ENCRYPT_PASSWORD,
        ERROR_NON_ACCESS_TO_BO_AUTHORIZED,
        ERROR_DISPLAY_AJAX
    }

    private static final Throwable DEFAULT_THROWABLE = null;
}
